"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
function typesafeContextHook(name, hook) {
    const Context = (0, react_1.createContext)(null);
    const Provider = ({ children }) => {
        const value = hook();
        return <Context.Provider value={value}>{children}</Context.Provider>;
    };
    function useNamedCustomHook() {
        const value = (0, react_1.useContext)(Context);
        if (value === null) {
            throw new Error(`use${name} must be used within a ${name}Provider`);
        }
        return value;
    }
    function withHook(WrappedComponent) {
        return function WrappedWithHook(props) {
            return (<Provider>
          <WrappedComponent {...props}/>
        </Provider>);
        };
    }
    return {
        [`use${name}`]: useNamedCustomHook,
        [`${name}Provider`]: Provider,
        [`with${name}`]: withHook,
    };
}
exports.default = typesafeContextHook;
